/*!
 * @pixi/filter-advanced-bloom - v2.3.0
 * Compiled Tue, 31 Oct 2017 18:03:02 UTC
 *
 * pixi-filters is licensed under the MIT License.
 * http://www.opensource.org/licenses/mit-license
 */
!function(e,o){"object"==typeof exports&&"undefined"!=typeof module?o(exports):"function"==typeof define&&define.amd?define(["exports"],o):o(e.__filter_advanced_bloom={})}(this,function(e){"use strict";var o="\nattribute vec2 aVertexPosition;\nattribute vec2 aTextureCoord;\nuniform mat3 projectionMatrix;\nvarying vec2 vTextureCoord;\n\nvoid main() {\n    gl_Position = vec4((projectionMatrix * vec3(aVertexPosition, 1.0)).xy, 0.0, 1.0);\n    vTextureCoord = aTextureCoord;\n}\n",t="\nuniform sampler2D uSampler;\nvarying vec2 vTextureCoord;\n\nuniform float threshold;\n\nvoid main() {\n    vec4 color = texture2D(uSampler, vTextureCoord);\n\n    // A simple & fast algorithm for getting brightness.\n    // It's inaccuracy , but good enought for this feature.\n    float _max = max(max(color.r, color.g), color.b);\n    float _min = min(min(color.r, color.g), color.b);\n    float brightness = (_max + _min) * 0.5;\n\n    if(brightness > threshold) {\n        gl_FragColor = color;\n    } else {\n        gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);\n    }\n}\n",r=function(e){function r(r){void 0===r&&(r=.5),e.call(this,o,t),this.threshold=r}e&&(r.__proto__=e),(r.prototype=Object.create(e&&e.prototype)).constructor=r;var n={threshold:{configurable:!0}};return n.threshold.get=function(){return this.uniforms.threshold},n.threshold.set=function(e){this.uniforms.threshold=e},Object.defineProperties(r.prototype,n),r}(PIXI.Filter),n="attribute vec2 aVertexPosition;\nattribute vec2 aTextureCoord;\nuniform mat3 projectionMatrix;\nvarying vec2 vTextureCoord;\n\nvoid main() {\n    gl_Position = vec4((projectionMatrix * vec3(aVertexPosition, 1.0)).xy, 0.0, 1.0);\n    vTextureCoord = aTextureCoord;\n}\n",i="uniform sampler2D uSampler;\nvarying vec2 vTextureCoord;\n\nuniform sampler2D bloomTexture;\nuniform float bloomScale;\nuniform float brightness;\n\nvoid main() {\n    vec4 color = texture2D(uSampler, vTextureCoord);\n    color.rgb *= brightness;\n    vec4 bloomColor = vec4(texture2D(bloomTexture, vTextureCoord).rgb, 0.0);\n    bloomColor.rgb *= bloomScale;\n    gl_FragColor = color + bloomColor;\n}\n",l=function(e){function o(o){e.call(this,n,i),"number"==typeof o&&(o={threshold:o}),o=Object.assign({threshold:.5,bloomScale:1,brightness:1,blur:8,quality:4,resolution:PIXI.settings.RESOLUTION,kernelSize:5},o),this.bloomScale=o.bloomScale,this.brightness=o.brightness;var t=o.blur,l=o.quality,s=o.resolution,u=o.kernelSize,a=PIXI.filters,c=a.BlurXFilter,h=a.BlurYFilter;this._extract=new r(o.threshold),this._blurX=new c(t,l,s,u),this._blurY=new h(t,l,s,u)}e&&(o.__proto__=e),(o.prototype=Object.create(e&&e.prototype)).constructor=o;var t={threshold:{configurable:!0},blur:{configurable:!0}};return o.prototype.apply=function(e,o,t,r,n){var i=e.getRenderTarget(!0);this._extract.apply(e,o,i,!0,n),this._blurX.apply(e,i,i,!0,n),this._blurY.apply(e,i,i,!0,n),this.uniforms.bloomScale=this.bloomScale,this.uniforms.brightness=this.brightness,this.uniforms.bloomTexture=i,e.applyFilter(this,o,t,r),e.returnRenderTarget(i)},t.threshold.get=function(){return this._extract.threshold},t.threshold.set=function(e){this._extract.threshold=e},t.blur.get=function(){return this._blurX.blur},t.blur.set=function(e){this._blurX.blur=this._blurY.blur=e},Object.defineProperties(o.prototype,t),o}(PIXI.Filter);PIXI.filters.AdvancedBloomFilter=l,e.AdvancedBloomFilter=l,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=filter-advanced-bloom.js.map
